diff --git a/src/iwd.ap.rst b/src/iwd.ap.rst
index 9ad002a2..7bc81186 100644
--- a/src/iwd.ap.rst
+++ b/src/iwd.ap.rst
@@ -33,7 +33,7 @@ method is used.
 FILE FORMAT
 ===========
 
-See *iwd.network* for details on the settings file syntax.
+See **iwd.network**\(5) for details on the settings file syntax.
 
 SETTINGS
 ========
@@ -62,7 +62,7 @@ The group ``[General]`` contains general AP configuration.
        Note: Due to regulatory requirements the linux kernel does not allow or
        strictly limits 5GHz use in AP mode while in world roaming. These
        frequencies become available once the country is set, either via IWD's
-       main.conf option ``[General].Country`` (see ``man iwd.config``) or
+       main.conf option ``[General].Country`` (see **iwd.config**\(5)) or
        externally (e.g. iw reg set <CC>). If you are having trouble using 5GHz
        ensure the country is set, and that the desired frequency/channel is
        unrestricted.
@@ -122,7 +122,7 @@ IPv4 Network Configuration
 
 The group ``[IPv4]`` contains settings for IWD's built-in DHCP server.  All
 settings are optional.  They're used if network configuration was enabled as
-described in ``iwd.config(5)``.  Omitting the ``[IPv4]`` group disables
+described in **iwd.config**\(5).  Omitting the ``[IPv4]`` group disables
 network configuration for this access point so if an all-defaults DHCP setup
 is desired, the group header line must still be present:
 
@@ -230,4 +230,4 @@ The group ``[WSC]`` fine-tunes some Wi-Fi Simple Configuration local parameters
 SEE ALSO
 ========
 
-iwd(8), iwd.network(5)
+**iwd**\(8), **iwd.network**\(5)
diff --git a/src/iwd.config.rst b/src/iwd.config.rst
index b3dc22d4..93f845fe 100644
--- a/src/iwd.config.rst
+++ b/src/iwd.config.rst
@@ -35,7 +35,7 @@ chosen.  The presence of *main.conf* is not required.
 FILE FORMAT
 ===========
 
-See *iwd.network* for details on the file format.
+See **iwd.network**\(5) for details on the file format.
 
 SETTINGS
 ========
@@ -381,4 +381,4 @@ The group ``[IPv4]`` contains settings related to IPv4 network configuration.
 SEE ALSO
 ========
 
-iwd(8), iwd.network(5)
+**iwd**\(8), **iwd.network**\(5)
diff --git a/src/iwd.debug.rst b/src/iwd.debug.rst
index 3d4c8b58..7ca17de2 100644
--- a/src/iwd.debug.rst
+++ b/src/iwd.debug.rst
@@ -47,4 +47,4 @@ The granularity of the DHCP logging can also be tailored by setting
 SEE ALSO
 ========
 
-iwd(8), iwmon(1)
+**iwd**\(8), **iwmon**\(1)
diff --git a/src/iwd.network.rst b/src/iwd.network.rst
index 719853fa..f7128336 100644
--- a/src/iwd.network.rst
+++ b/src/iwd.network.rst
@@ -133,14 +133,14 @@ The group ``[Settings]`` contains general settings.
 
        If enabled, the MAC address will be fully randomized on each connection.
        This option is only used if [General].AddressRandomization is set to
-       'network'. See iwd.config. This setting should not be used with
+       'network'. See **iwd.config**\(5). This setting should not be used with
        [Settings].AddressOverride, if both are set AddressOverride will be used.
    * - AddressOverride
      - MAC address string
 
        Override the MAC address used for connecting to this network. This option
        is only used if [General].AddressRandomization is set to 'network'. See
-       iwd.config. This setting should not be used with
+       **iwd.config**\(5). This setting should not be used with
        [Settings].AlwaysRandomizeAddress, if both are set AddressOverride will
        be used.
    * - TransitionDisable
@@ -180,7 +180,7 @@ Network Authentication Settings
 
 The group ``[Security]`` contains settings for Wi-Fi security and
 authentication configuration. This group can be encrypted by enabling
-``SystemdEncrypt``, see *iwd.config* for details on this option. If this
+``SystemdEncrypt``, see **iwd.config**\(5) for details on this option. If this
 section is encrypted (only contains EncryptedSalt/EncryptedSecurity) it should
 not be modified. Modifying these values will result in the inability to
 connect to that network.
@@ -541,4 +541,4 @@ PEAP + MSCHAPv2
 SEE ALSO
 ========
 
-iwd(8), iwd.config(5)
+**iwd**\(8), **iwd.config**\(5)
diff --git a/src/iwd.rst b/src/iwd.rst
index c719fbc2..bb6e9c04 100644
--- a/src/iwd.rst
+++ b/src/iwd.rst
@@ -44,19 +44,19 @@ OPTIONS
 ENVIRONMENT
 ===========
 
-*$STATE_DIRECTORY* is used for network configuration files.  See *iwd.network*
-for details.
+*$STATE_DIRECTORY* is used for network configuration files.  See
+**iwd.network**\(5) for details.
 
 *$CONFIGURATION_DIRECTORY* is used for daemon configuration settings.  Only
-the file **main.conf** is currently read from this directory.  See *iwd.config*
-for details.
+the file **main.conf** is currently read from this directory.  See
+**iwd.config**\(5) for details.
 
-See *iwd.debug* for further environment variables for debugging.
+See **iwd.debug**\(7) for further environment variables for debugging.
 
 SEE ALSO
 ========
 
-iwd.config(5), iwd.network(5), iwd.debug(7), iwctl(1), iwmon(1), hwsim(1),
-ead(8), systemd.exec(5)
+**iwd.config**\(5), **iwd.network**\(5), **iwd.debug**\(7), **iwctl**\(1),
+**iwmon**\(1), **hwsim**\(1), **ead**\(8), **systemd.exec**\(5)
 
 http://iwd.wiki.kernel.org